' Interface to a DS1302 RTC
' Maximite Basic by Anthony Vine 2011
Clear
Cls
ce=20 ' clock enable pin
clk=19 ' clock pin
din = 18 ' read pin
dout = 18 ' write pin. normally is same as din
SetPin ce,9
SetPin clk,9
' SETPIN din,2 'only required for different din/dout
SetPin dout,9
GoSub Init
Start:
Pin(ce)=0
Pin(clk)=0
Pin(dout)=0
Cls
Print "*** DS 1302 Clock ***"
Print
Print "1 - set hours"
Print "2 - set minutes"
Print "3 - set seconds"
Print "4 - set day"
Print "5 - set month"
Print "6 - set year"
Print "r - read time"
Print "u - update clock"
Print "q - quit"
Print
Print "Select : "
'
Keyin:
inp$=Inkey$ :If inp$="" Then GoTo Keyin
If inp$="r" Then inp$="x"
If inp$="1" Then GoSub HourW
If inp$="2" Then GoSub MinW
If inp$="3" Then GoSub SecW
If inp$="4" Then GoSub DateW
If inp$="5" Then GoSub MonthW
If inp$="6" Then GoSub YearW
If inp$="u" Then GoSub ReadC :Time$=Time1$ :Pause 3000 :inp$=Chr$(13)
If inp$="x" Then GoSub ReadC :Pause 3000 :inp$=Chr$(13)
If inp$="q" Then Locate 0,240 :End
If Asc(inp$)=13 Then GoTo Start
Locate 0,130 :GoTo Keyin
'
ReadC:
' ----- read -------
Locate 0,160
Print "old time ";Time$
bitdata$="10000101" :GoSub ReadB :hr$=hi$+lo$
bitdata$="10000011" :GoSub ReadB :min$=hi$+lo$
bitdata$="10000001" :GoSub ReadB :sec$=hi$+lo$
Time1$=hr$+":"+min$+":"+sec$
Print "new time ";Time1$
bitdata$="10000111" :GoSub ReadB :dat$=hi$+lo$
bitdata$="10001001" :GoSub ReadB :mnt$=hi$+lo$
bitdata$="10001101" :GoSub ReadB :year$="20"+hi$+lo$
Print dat$;"/";mnt$;"/";year$ : Date$=dat$+"/"+mnt$+"/"+year$
Return
ReadB:
'read byte required and process
'data is in 2 x 4 bit nibbles
dataout$ = ""
GoSub ReadRTC
For p = 1 To 8 Step 4 'this sets the first bit to read. 1 or 5
Rem PRINT MID$(dataout$,p,4);
bitval = Val(Mid$(dataout$,p,1))
bitval=bitval + 2 * (Val(Mid$(dataout$,p+1,1)))
bitval=bitval + 4 * (Val(Mid$(dataout$,p+2,1)))
bitval=bitval + 8 * (Val(Mid$(dataout$,p+3,1)))
Rem PRINT bitval;"   ";
If p=1 Then lo$=Str$(bitval) Else hi$=Str$(bitval)
bitval = 0
Next p
Return
ReadRTC:
' ------ read from RTC --------
Pin(ce)=1
'step 1. write address to read
For i = 8 To 1 Step -1
bit =Val(Mid$(bitdata$,i,1))
Pin(dout)=bit
Pin(clk)=1
If i>1 Then Pin(clk)=0 'must leave clk high on transistion from write to r
Next i
Pin(dout)=1 'must leave dout high to be able to read din
'step 2. read data coming back
For i = 1 To 8
Pin(clk)=0 ' read is on the fall of the clock
dataout$=dataout$+Str$(Pin(din))
Pin(clk)=1
Next i
Pin(ce)=0
Pin(dout)=0
Pin(clk)=0
Return
Rem

Rem ------ write to RTC ---------
Init:
bitdata$="10001110"
wbitdata$="00000000"
GoSub WriteRTC
Return
'
SecW:
Locate 0,200 :Input "Input Sec. - ";a$
GoSub ConvNibbles
bitdata$="10000000":GoSub WriteRTC
inp$="x" :Return
'
MinW:
Locate 0,200 :Input "Input Min. - ";a$
GoSub ConvNibbles
bitdata$="10000010"
GoSub WriteRTC
inp$="x" :Return
'
HourW:
Locate 0,200 :Input "Input Hour - ";a$
GoSub ConvNibbles
bitdata$="10000100"
GoSub WriteRTC
inp$="x" :Return
'
'
DateW:
Locate 0,200 :Input "Input Date  - ";a$
GoSub ConvNibbles
bitdata$="10000110"
GoSub WriteRTC
inp$="x" :Return
'
MonthW:
Locate 0,200 :Input "Input Month - ";a$
GoSub ConvNibbles
bitdata$="10001000"
GoSub WriteRTC
inp$="x" :Return
'
YearW:
Locate 0,200 :Input "Input Year  - 20";a$
GoSub ConvNibbles
bitdata$="10001100"
GoSub WriteRTC
inp$="x" :Return
'
WriteRTC:
Rem ------ write to RTC --------
Pin(ce)=1
Pin(clk)=0
For c = 1 To 2 '2 bytes to write
For i = 8 To 1 Step -1
bit=Val(Mid$(bitdata$,i,1))
Pin(dout)=bit
Pin(clk)=1
Pin(clk)=0
Next i
bitdata$=wbitdata$
Next c
Pause 10
Pin(ce)=0
Pin(dout)=0
Pin(clk)=0
wbitdata$=""
Return
'
ConvNibbles:
Value = Val(a$)
If Value <10 Then ValueH=0 :ValueL=Value : GoTo BinC
aH$ = Left$(a$,1)
ValueH = Val(aH$)
aL$ = Right$(a$,1)
ValueL = Val(aL$)
'
BinC:
b$ = Bin$(ValueH)
If Len(b$) = 3 Then b$="0"+b$
If Len(b$) = 2 Then b$="00"+b$
If Len(b$) = 1 Then b$="000"+b$
'
c$ = Bin$(ValueL)
If Len(c$) = 3 Then c$="0"+c$
If Len(c$) = 2 Then c$="00"+c$
If Len(c$) = 1 Then C$="000"+c$
'
wbitdata$ = b$+c$
Print
Return
End
